# Find the boost-log module
# Once found the following variables are set :
#	boost-log_FOUND	True to specify that the module has been found
#
#	boost-log_INCLUDE_DIRS	Path(s) to the headers
#
#	boost-log_LIBRARIES	Link these to use boost-log

# To help CMake in finding the boost-log module
# one can set the following variables :
# boost-log_DIR	Those variables can be either set using 'set' command of
# or			CMake, or using '-D<var>=value' while calling CMake or 
# boost-log_ROOT	finally they can be set as environment variables.
# or			Those three variables are aliases, so just set one is enough.
# boost-logROOT
#
# You can set any of them using one of the following methods :
#	1) Set it as environnement varialbe (e.g. export)
#	2) Give it as argument for cmake : cmake -Dboost-log_DIR="...."
#	3) In a CMakeLists.txt, set a variable : set(boost-log_DIR ...)	

#Varaibles to change if the module changes
#set(HEADER_FILES asio_fwd.hpp async_frontend.hpp attachable_sstream_buf.hpp attr.hpp attr.hpp attribute.hpp attribute_mapping.hpp attribute_set.hpp attributes.hpp attribute_value_extractor.hpp attribute_values_view.hpp auto_flush.hpp basic_attribute_value.hpp basic_filters.hpp basic_formatters.hpp basic_logger.hpp basic_sink_backend.hpp basic_sink_frontend.hpp c_decorator.hpp chain.hpp channel_feature.hpp channel.hpp channel_logger.hpp char_decorator.hpp cleanup_scope_guard.hpp clock.hpp code_conversion.hpp common_attributes.hpp common.hpp constant.hpp core.hpp core.hpp counter.hpp csv_decorator.hpp current_process_id.hpp current_thread_id.hpp date_time.hpp date_time_types.hpp debug_output_backend.hpp delimiter.hpp depth.hpp dynamic_type_dispatcher.hpp embedded_string_type.hpp empty_deleter.hpp event_log_backend.hpp event_log_constants.hpp exception_handler_feature.hpp exception_handler.hpp exception.hpp exception_policies.hpp exception_policies.hpp exceptions.hpp facility.hpp features.hpp file_name.hpp filter.hpp filter_parser.hpp filters.hpp format.hpp format.hpp formatter_parser.hpp formatters.hpp from_settings.hpp from_stream.hpp functional.hpp function_traits.hpp functor.hpp global_logger_storage.hpp has_attr.hpp if.hpp intrusive_ref_counter.hpp ip_version.hpp iteration.hpp light_rw_mutex.hpp locking_ptr.hpp log_name.hpp log_source.hpp max_size.hpp message_file.hpp message.hpp min_free_space.hpp multiple_lock.hpp mutable_constant.hpp named_scope.hpp named_scope.hpp native_typeof.hpp no_unused_warnings.hpp nt6_event_log_backend.hpp nt6_event_log_constants.hpp open_mode.hpp order.hpp ordering_async_frontend.hpp ordering_window.hpp parameter_tools.hpp process_id.hpp prologue.hpp provider_id.hpp record.hpp record_ordering.hpp record_ostream.hpp regex.hpp registration.hpp rotation_size.hpp scan_method.hpp scoped_attribute.hpp setup_prologue.hpp severity_channel_logger.hpp severity_feature.hpp severity.hpp severity_logger.hpp shared_lock_guard.hpp singleton.hpp sink.hpp sink_init_helpers.hpp sinks.hpp slim_string.hpp snprintf.hpp spirit_classic.hpp spirit_qi.hpp standard_types.hpp start_thread.hpp static_type_dispatcher.hpp stream.hpp string_literal.hpp sync_frontend.hpp syslog_backend.hpp syslog_constants.hpp tagged_integer.hpp target.hpp templated_shared_from_this.hpp text_file_backend.hpp text_multifile_backend.hpp text_ostream_backend.hpp threading_models.hpp threading_models.hpp thread_specific.hpp time_based_rotation.hpp timer.hpp time_traits.hpp to_console.hpp to_file.hpp trivial.hpp type_dispatcher.hpp type_info_wrapper.hpp unique_identifier_name.hpp unit_format.hpp universal_path.hpp unlocked_frontend.hpp unspecified_bool.hpp use_impl.hpp wrappers.hpp xml_decorator.hpp xpressive.hpp)
set(HEADER_FILES boost/log/attributes.hpp boost/log/attributes/attribute.hpp boost/log/attributes/attribute_set.hpp boost/log/attributes/attribute_values_view.hpp boost/log/attributes/basic_attribute_value.hpp boost/log/attributes/clock.hpp boost/log/attributes/constant.hpp boost/log/attributes/counter.hpp boost/log/attributes/current_process_id.hpp boost/log/attributes/current_thread_id.hpp boost/log/attributes/functor.hpp boost/log/attributes/mutable_constant.hpp boost/log/attributes/named_scope.hpp boost/log/attributes/time_traits.hpp boost/log/attributes/timer.hpp boost/log/common.hpp boost/log/core.hpp boost/log/core/core.hpp boost/log/core/record.hpp boost/log/detail/asio_fwd.hpp boost/log/detail/attachable_sstream_buf.hpp boost/log/detail/cleanup_scope_guard.hpp boost/log/detail/code_conversion.hpp boost/log/detail/embedded_string_type.hpp boost/log/detail/function_traits.hpp boost/log/detail/functional.hpp boost/log/detail/light_rw_mutex.hpp boost/log/detail/locking_ptr.hpp boost/log/detail/multiple_lock.hpp boost/log/detail/native_typeof.hpp boost/log/detail/parameter_tools.hpp boost/log/detail/process_id.hpp boost/log/detail/prologue.hpp boost/log/detail/setup_prologue.hpp boost/log/detail/shared_lock_guard.hpp boost/log/detail/singleton.hpp boost/log/detail/sink_init_helpers.hpp boost/log/detail/snprintf.hpp boost/log/detail/tagged_integer.hpp boost/log/detail/templated_shared_from_this.hpp boost/log/detail/thread_specific.hpp boost/log/detail/universal_path.hpp boost/log/detail/unspecified_bool.hpp boost/log/exceptions.hpp boost/log/filters.hpp boost/log/filters/attr.hpp boost/log/filters/basic_filters.hpp boost/log/filters/exception_policies.hpp boost/log/filters/has_attr.hpp boost/log/formatters.hpp boost/log/formatters/attr.hpp boost/log/formatters/basic_formatters.hpp boost/log/formatters/c_decorator.hpp boost/log/formatters/chain.hpp boost/log/formatters/char_decorator.hpp boost/log/formatters/csv_decorator.hpp boost/log/formatters/date_time.hpp boost/log/formatters/exception_policies.hpp boost/log/formatters/format.hpp boost/log/formatters/if.hpp boost/log/formatters/message.hpp boost/log/formatters/named_scope.hpp boost/log/formatters/stream.hpp boost/log/formatters/wrappers.hpp boost/log/formatters/xml_decorator.hpp boost/log/keywords/auto_flush.hpp boost/log/keywords/channel.hpp boost/log/keywords/delimiter.hpp boost/log/keywords/depth.hpp boost/log/keywords/facility.hpp boost/log/keywords/file_name.hpp boost/log/keywords/filter.hpp boost/log/keywords/format.hpp boost/log/keywords/ip_version.hpp boost/log/keywords/iteration.hpp boost/log/keywords/log_name.hpp boost/log/keywords/log_source.hpp boost/log/keywords/max_size.hpp boost/log/keywords/message_file.hpp boost/log/keywords/min_free_space.hpp boost/log/keywords/open_mode.hpp boost/log/keywords/order.hpp boost/log/keywords/ordering_window.hpp boost/log/keywords/provider_id.hpp boost/log/keywords/registration.hpp boost/log/keywords/rotation_size.hpp boost/log/keywords/scan_method.hpp boost/log/keywords/severity.hpp boost/log/keywords/start_thread.hpp boost/log/keywords/target.hpp boost/log/keywords/time_based_rotation.hpp boost/log/keywords/unit_format.hpp boost/log/keywords/use_impl.hpp boost/log/sinks.hpp boost/log/sinks/async_frontend.hpp boost/log/sinks/attribute_mapping.hpp boost/log/sinks/basic_sink_backend.hpp boost/log/sinks/basic_sink_frontend.hpp boost/log/sinks/debug_output_backend.hpp boost/log/sinks/event_log_backend.hpp boost/log/sinks/event_log_constants.hpp boost/log/sinks/nt6_event_log_backend.hpp boost/log/sinks/nt6_event_log_constants.hpp boost/log/sinks/ordering_async_frontend.hpp boost/log/sinks/sink.hpp boost/log/sinks/sync_frontend.hpp boost/log/sinks/syslog_backend.hpp boost/log/sinks/syslog_constants.hpp boost/log/sinks/text_file_backend.hpp boost/log/sinks/text_multifile_backend.hpp boost/log/sinks/text_ostream_backend.hpp boost/log/sinks/threading_models.hpp boost/log/sinks/unlocked_frontend.hpp boost/log/sources/basic_logger.hpp boost/log/sources/channel_feature.hpp boost/log/sources/channel_logger.hpp boost/log/sources/exception_handler_feature.hpp boost/log/sources/features.hpp boost/log/sources/global_logger_storage.hpp boost/log/sources/record_ostream.hpp boost/log/sources/severity_channel_logger.hpp boost/log/sources/severity_feature.hpp boost/log/sources/severity_logger.hpp boost/log/sources/threading_models.hpp boost/log/support/exception.hpp boost/log/support/regex.hpp boost/log/support/spirit_classic.hpp boost/log/support/spirit_qi.hpp boost/log/support/xpressive.hpp boost/log/trivial.hpp boost/log/utility/attribute_value_extractor.hpp boost/log/utility/empty_deleter.hpp boost/log/utility/exception_handler.hpp boost/log/utility/init/common_attributes.hpp boost/log/utility/init/filter_parser.hpp boost/log/utility/init/formatter_parser.hpp boost/log/utility/init/from_settings.hpp boost/log/utility/init/from_stream.hpp boost/log/utility/init/to_console.hpp boost/log/utility/init/to_file.hpp boost/log/utility/intrusive_ref_counter.hpp boost/log/utility/no_unused_warnings.hpp boost/log/utility/record_ordering.hpp boost/log/utility/scoped_attribute.hpp boost/log/utility/slim_string.hpp boost/log/utility/string_literal.hpp boost/log/utility/type_dispatch/date_time_types.hpp boost/log/utility/type_dispatch/dynamic_type_dispatcher.hpp boost/log/utility/type_dispatch/standard_types.hpp boost/log/utility/type_dispatch/static_type_dispatcher.hpp boost/log/utility/type_dispatch/type_dispatcher.hpp boost/log/utility/type_info_wrapper.hpp boost/log/utility/unique_identifier_name.hpp)
set(INCLUDE_PATH_SUFFIXES include/)
set(LIBRARIES libboost_log-mt.so)

foreach(header ${HEADER_FILES})
	find_path(${header}_PATH ${header} PATH_SUFFIXES ${INCLUDE_PATH_SUFFIXES}
	HINTS ${boost-log_DIR} ${boost-log_ROOT} ${boost-logROOT}
	$ENV{boost-log_DIR} $ENV{boost-log_ROOT} $ENV{boost-logROOT})
	if(${header}_PATH)
		list(APPEND boost-log_INCLUDE_DIRS ${${header}_PATH})
		unset(${header}_PATH CACHE)
	else(${header}_PATH)
		list(APPEND MISSING_HEADERS ${header})
	endif(${header}_PATH)
endforeach()

if(boost-log_INCLUDE_DIRS)
	list(REMOVE_DUPLICATES boost-log_INCLUDE_DIRS)
endif(boost-log_INCLUDE_DIRS)

if(MISSING_HEADERS)
	unset(boost-log_INCLUDE_DIRS)
endif(MISSING_HEADERS)

find_file(boost-log_LIBRARIES ${LIBRARIES} PATH_SUFFIXES lib 
	HINTS ${boost-log_DIR} ${boost-log_ROOT} ${boost-logROOT}
	$ENV{boost-log_DIR} $ENV{boost-log_ROOT} $ENV{boost-logROOT})

if(boost-log_INCLUDE_DIRS AND boost-log_LIBRARIES)
	set(boost-log_FOUND TRUE)
else(boost-log_INCLUDE_DIRS AND boost-log_LIBRARIES)
	if(NOT boost-log_FIND_QUIETLY)
		if(NOT boost-log_INCLUDE_DIRS)
			message(STATUS "Unable to find boost-log, the following header files are missing : ${MISSING_HEADERS}")
		else(NOT boost-log_INCLUDE_DIRS)
			message(STATUS "Header files found.")
		endif(NOT boost-log_INCLUDE_DIRS)
		if(NOT boost-log_LIBRARIES)
			message(STATUS "Unable to find boost-log library files!")
		else(NOT boost-log_LIBRARIES)
			message(STATUS "Library files found.")
		endif(NOT boost-log_LIBRARIES)
	endif(NOT boost-log_FIND_QUIETLY)
endif(boost-log_INCLUDE_DIRS AND boost-log_LIBRARIES)

if(boost-log_FOUND)
	if(NOT boost-log_FIND_QUIETLY)
		message(STATUS "Found components for boost-log")
		message(STATUS "boost-log_INCLUDE_DIRS = ${boost-log_INCLUDE_DIRS}")
		message(STATUS "boost-log_LIBRARIES = ${boost-log_LIBRARIES}")
	endif(NOT boost-log_FIND_QUIETLY)
else(boost-log_FOUND)
	if(boost-log_FIND_REQUIRED)
		set(boost-log_DIR "" CACHE PATH "Paths where to additionally look for
		boost-log (alias of boost-log_ROOT and boost-logROOT)")
		set(boost-log_ROOT "" CACHE PATH "Paths where to additionally look for
		boost-log (alias of boost-log_DIR and boost-logROOT)")
		set(boost-logROOT "" CACHE PATH "Paths where to additionally look for
		boost-log (alias of boost-log_DIR and boost-log_ROOT)")
		if(NOT boost-log_FIND_QUIETLY)
			message("\nCould not find boost-log!\n")
			message("You can use any of the following variables to help CMake to find the header files and libraries :")
			message("	boost-log_DIR or boost-log_ROOT or boost-logROOT")
			message("You should use one and set it to the root path of your local boost-log install directory (if you installed it in a different folder than system root).")
			message("To set one you can either :")
			message("	- use 'set(boost-log_DIR ....)' command in the CMakeLists.txt (separator ' ')")
			message("	- use '-Dboost-log_DIR=....' as an option to Cmake (separator ';')")
			message("	- set one as an environment variable (e.g. export in bash, with separator ';')\n")
		endif(NOT boost-log_FIND_QUIETLY)
		message(FATAL_ERROR "Could not find boost-log!")
	endif(boost-log_FIND_REQUIRED)
endif(boost-log_FOUND)

mark_as_advanced (
	boost-log_FOUND
	boost-log_LIBRARIES
	boost-log_INCLUDE_DIRS
)
